var runner, slideAnimation;
var delta;
var stretchWidth;
var rb_fileCount;
var rb_fileSize;
var binType; // 0: default empty; 1: default full; 2 hover empty; 3: hover full
var lastBinType;
var imgFolder;

var defaultEmptyImg;
var defaultFullImg;
var hoverEmptyImg;
var hoverFullImg;
var sliderInterval;
var runnerLeave;
var oldBinType;
var tfSetTimeOut;

//
// Note: Recycle Bin has two timers
//
// One timer is running at the background all the time. It's used to detect if any file is added into recycle bin.
// Another timer is only running when the sliding drawer is triggered. 
// 


 
function onLoad()
{
    setImages();
    reset();
    window.external.system.shell.recyclebin.onrecyclebinchanged = checkBinType;
    window.external.OnSettingsChanged = onSettingChanged;
   

    onMouseLeave();

}
function openBinFolder()
{
    var ssfBitBucket = 0xa;
    var rbfldr = window.external.System.Shell.Explorer.NameSpace(ssfBitBucket);
    rbfldr.Self.InvokeVerb('open');
}
function onSettingChanged()
{
    setImages();
    onMouseLeave();
}

function setImages()
{
    var folder = window.external.Settings.Read("ImageFolder");
    var prefix;
    if (folder)
    {                          
        imgFolder = folder.replace("/", "\\"); //changes slashes to accomodate window.external.background
    }
    else
    {
        imgFolder = "view1\\";
    }
    prefix = imgFolder.replace("\\", "_");
    // set RB images
    defaultEmptyImg = imgFolder + prefix + "default.png";
    defaultFullImg = imgFolder + prefix + "default_full.png";
    hoverEmptyImg = imgFolder + prefix + "hover.png";
    hoverFullImg = imgFolder + prefix + "hover_full.png";
    slide_right_img.src = imgFolder + prefix + "slider_right.gif";
    slide_stretch_img.src = imgFolder + prefix + "slider_stretch.gif";
    slide_left_img.src = imgFolder + prefix + "slider_left.gif";
}

function showDrawerParts()
{
    slide_right_img.style.visibility = "visible";
    slide_stretch_img.style.visibility = "visible";
    slide_left_img.style.visibility = "visible";
    main.style.visibility = "visible";
}

function hideDrawerParts()
{
    slide_right_img.style.visibility = "hidden";
    slide_stretch_img.style.visibility = "hidden";
    slide_left_img.style.visibility = "hidden";
    main.style.visibility = "hidden";
}

function reset()
{
    hideDrawerParts();
    
    slideAnimation = 0; // 1: slideout; 2: slidein
    stretchWidth = 1;
    delta = 5;
    if (runner)
        clearInterval(runner);
    runner = null;
}

function adjustPosition(pos, delta)
{
    pos = delta + parseInt(pos.replace("px", "")) + "px";
    return pos;
}

function getFolderSize()
{
    return window.external.System.Shell.RecycleBin.SizeUsed;
}

function getFolderFileCount()
{
    return window.external.System.Shell.RecycleBin.FileCount + window.external.System.Shell.RecycleBin.FolderCount;
}

function emptyRB()
{
    if ( getFolderFileCount() > 0)
    { 
        window.external.System.Shell.RecycleBin.EmptyAll();
        slideAnimation = 2;
        onMouseLeave();
        window.external.System.Sound.beep();
    }
}

function checkBinType()
{
    // check bin type
    if (parseInt(getFolderFileCount()))
        binType = (oldBinType > 1 ? 3 : 1);
    else
        binType = (oldBinType > 1 ? 2 : 0);

    //if (binType != oldBinType)
        changeBinType();
}

function sliding(delta)
{
    stretchWidth += delta;
    slide_stretch_img.style.left = adjustPosition(slide_stretch_img.style.left, -delta);
    slide_stretch_img.width = stretchWidth;
    slide_left_img.style.left = adjustPosition(slide_left_img.style.left, -delta);
    rbEmptyBtn.style.left = rbItems.style.left = rbSize.style.left = adjustPosition(rbSize.style.left, -delta);
}
    
function animation(){
    imgs = document.getElementById("main").getElementsByTagName("img");

    if (slideAnimation == 1)
    {
        if (stretchWidth < 62)
        { // 1 is the minimum of stretchWidth. 
            showDrawerParts();        
            sliding(delta);
            setTimeout( "animation()", 2 );
         }  
    }
    if (slideAnimation == 2)
    { 
        if (stretchWidth > 0)
        { // 1 is the minimum of stretchWidth. 
            sliding(-delta);
            setTimeout( "animation()", 2 );
        }   
        else 
        {
             hideDrawerParts();
        }  
    }

}


function onMouseUp()
{
    if (!slideAnimation)
        slideAnimation = 1;
    else
        slideAnimation = 3 - slideAnimation; // alternate between 1 and 2. 1 is slide-out; 2 is slide-in
        
      animation();           
      
    if (slideAnimation == 1)
    {
        // query size and format text
        rb_fileSize = parseFloat(getFolderSize());
        if (rb_fileSize > (1024 * 1024) * 1024)
            rb_fileSize = Math.floor(rb_fileSize / ((1024 * 1024) * 1024)) + ((rem = Math.floor(rb_fileSize / ((1024 * 1024) * 1024) * 100) % 100) ? "." + rem : "") + " GB";
        else if (rb_fileSize > 1024 * 1024)
            rb_fileSize = Math.floor(rb_fileSize / (1024*1024)) + ((rem = Math.floor(rb_fileSize / (1024*1024) * 100) % 100) ? "." + rem : "") + " MB";
        else if (rb_fileSize > 1024)
            rb_fileSize = Math.floor(rb_fileSize / 1024) + ((rem = Math.floor(rb_fileSize / 1024 * 100) % 100) ? "." + rem : "") + " KB";
        else
            if (rb_fileSize == 0)
                rb_fileSize = rb_fileSize + " KB";
            else
                rb_fileSize = rb_fileSize + " B";
            
        rb_fileCount = getFolderFileCount() + " items";
        
        rbSize.innerHTML = rb_fileSize;
        rbItems.innerHTML = rb_fileCount;        
    }

    changeBinType();
}


function changeBinType()
{
    switch (binType)
    {
    case 0:
       window.external.background = "url(" + defaultEmptyImg + ")";
        break;
    case 1:
        window.external.background = "url(" + defaultFullImg + ")";
        break;
    case 2:
        window.external.background = "url(" + hoverEmptyImg + ")";
        break;
    case 3:
        window.external.background = "url(" + hoverFullImg + ")"
        break;
    }
    oldBinType = binType
}

function onMouseOver()
{
    if (parseInt(getFolderFileCount()))
    {
        binType = 3;            
    }
    else
    {
        binType = 2;
     }   
    changeBinType();
}

function onMouseLeave()
{
  if (parseInt(getFolderFileCount()))
  {
        binType = 1;
  }
  else
  {
        binType = 0;
  }
  changeBinType();
}  
function slideIn()
{
    slideAnimation = 1;
    onMouseUp(); 
}
function slideOut()
{
    if ( tfSetTimeOut )
    {
        slideAnimation = 2;
        onMouseUp();
    }
}
function delaySlideOut()
{
        tfSetTimeOut = true;
        setTimeout('slideOut()', 1200);
}

function delaySlideIn()
{
        tfSetTimeOut=false;
        setTimeout('slideIn()', 180);
}

function onDropFile()
{
    var item;
    var index = 0;
    do
    { 
        item = window.external.System.Shell.ItemFromFileDrop(event.dataTransfer, index);
        if (item)
        {
            window.external.System.Shell.RecycleBin.DeleteItem(item.Path);
        }
        index++;
    } while (item != null);
    slideAnimation = null;
    onMouseUp(); 
    changeBinType();
}

