var selecteFolder;
var selectedIndex = 0;
var availFolders;

function getNumOfFolders()
{
    // check how many RB image folder, like view1, view2...
    var gadgetPath = window.external.System.Shell.GadgetPath;
    var count = 0;    
    var items = window.external.System.Shell.ItemFromPath(gadgetPath).Folder.Items;
    var tempFolders = new Array(items.Count);
    
    for (i = 0; i < items.Count; ++i)
    {
        var item = items.Item(i);
        if (item.Name.match(/^view\d+$/i) && item.IsFolder)
            tempFolders[count++] = item.Name;
    }
    
    if (count > 0)
    {
        availFolders = new Array(count);
        for (i = 0; i < count; i++)
            availFolders[i] = tempFolders[i];
    }            

    return count;    
}

function updateText()
{
    sel_text.innerHTML = (selectedIndex + 1) + " of " + availFolders.length;
}

function updateImages()
{
    var view = availFolders[selectedIndex];
   
    emptyImg.src = view + "/" + view + "_settingsEmpty.png";
    fullImg.src = view + "/" + view + "_settingsFull.png";
}

function onSelLeft()
{
    selectedIndex--;
    if (selectedIndex < 0)
        selectedIndex = availFolders.length - 1;
    
    updateText();
    updateImages();
}

function onSelRight()
{
    selectedIndex++;
    if (selectedIndex >= availFolders.length)
        selectedIndex = 0;

    updateText();
    updateImages();
}

function setCurrentFolder(folder)
{
    // write folder id to setting file
    window.external.Settings.Write("ImageFolder", folder);
}

function getCurrentFolder()
{

    // read folder id from setting file
    var folder = window.external.Settings.Read("ImageFolder");
   
    if (folder == null)
        folder = "view1/";
        
    return folder;        
}

function findDefaultIndex()
{
    var currentFolder = getCurrentFolder();
    
    for (var i in availFolders)
    {
        if (availFolders[i]+"/" == currentFolder)
            return (i * 1);
    }
    return 0;
}

function SaveSettings()
{
    setCurrentFolder(availFolders[selectedIndex] + "/");
}

function onLoad()
{
    getNumOfFolders();
    selectedIndex = findDefaultIndex();
    
    updateText();
    updateImages();
    
    window.external.OnSaveSettings = SaveSettings;
}